diff -ur avtnatpmpd.orig/avtnatpmp.c avtnatpmpd/avtnatpmp.c
--- avtnatpmpd.orig/avtnatpmp.c	2008-11-09 21:19:59.000000000 +0300
+++ avtnatpmpd/avtnatpmp.c	2008-12-13 06:30:48.000000000 +0300
@@ -789,7 +789,13 @@
 		} else {		/* Addition request. */
 			time_t timestamp, curtime;
 
-			if (locport == 0) {
+			if (locport<40000 || locport>45000) {
+				resp.rescode = htons(NATPMP_RESULT_NOTAUTH);
+				syslog(LOG_WARNING, "client %s tries to add "
+					"NAT-PMP to denied port range, denying request", locaddr);
+				goto sendit;
+			}
+			else if (locport == 0) {
 				resp.rescode = htons(NATPMP_RESULT_NOTAUTH);
 				syslog(LOG_NOTICE, "client %s tries to redirect "
 					"prohibited port, denying request", locaddr);
@@ -847,7 +853,7 @@
 			 * to client prior to this.
 			 */
 			if (pubport == 0)	/* Client lefts choice to us */
-				pubport = 1024;
+				pubport = 40000;
 			if (ce != NULL)
 				pubport = ce->pubport;
 			else do {
@@ -859,6 +865,11 @@
 					resp.rescode = htons(NATPMP_RESULT_NORESOUR);
 					syslog(LOG_ERR, "no free public ports on %s", pubaddr);
 					goto sendit;
+				} else if (pubport<40000 || pubport>45000) {
+					resp.rescode = htons(NATPMP_RESULT_NOTAUTH);
+					syslog(LOG_WARNING, "client %s tries to add "
+						"NAT-PMP to denied port range, denying request", locaddr);
+					goto sendit;
 				}
 			} while (i == 0);
 			/* Finally, do addition. */ 
